---
title: Node.appendChild()
slug: Web/API/Node/appendChild
tags:
  - API
  - DOM
  - Method
  - Node
  - Reference
---
<div>{{APIRef("DOM")}}</div>

<p>The <code><strong>Node.appendChild()</strong></code> method adds a node to the end of the list of children of a specified parent node. If the given child is a reference to an existing node in the document, <code>appendChild()</code> moves it from its current position to the new position (there is no requirement to remove the node from its parent node before appending it to some other node).</p>

<p>This means that a node can't be in two points of the document simultaneously. So if the node already has a parent, the node is first removed, then appended at the new position. The {{domxref("Node.cloneNode()")}} method can be used to make a copy of the node before appending it under the new parent. Note that the copies made with <code>cloneNode</code> will not be automatically kept in sync.</p>

<p>If the given child is a {{domxref("DocumentFragment")}}, the entire contents of the {{domxref("DocumentFragment")}} are moved into the child list of the specified parent node.</p>

<div class="notecard note">
<p><strong>Newer API available!</strong><br>
 The {{domxref("ParentNode.append()")}} method supports multiple arguments and appending strings.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>element</var>.appendChild(<var>aChild</var>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>aChild</var></code></dt>
 <dd>The node to append to the given parent node (commonly an element).</dd>
</dl>

<h3 id="Returns">Return value</h3>

<p>The returned value is the appended child (<code><var>aChild</var></code>), except when <code><var>aChild</var></code> is a {{domxref("DocumentFragment")}}, in which case the empty {{domxref("DocumentFragment")}} is returned.</p>

<h2 id="Notes">Notes</h2>

<p>Chaining may not work as expected, due to <code>appendChild()</code> returning the child element:</p>

<pre class="brush: js notranslate">let aBlock = document.createElement('block').appendChild( document.createElement('b') );</pre>

<p>Sets <code><var>aBlock</var></code> to <code>&lt;b&gt;&lt;/b&gt;</code> only, which is probably not what you want.</p>

<h2 id="Example">Example</h2>

<pre class="brush:js notranslate">// Create a new paragraph element, and append it to the end of the document body
let p = document.createElement("p");
document.body.appendChild(p);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-node-appendchild', 'Node.appendChild()')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>No change from {{SpecName("DOM3 Core")}}.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM3 Core', 'core.html#ID-184E7107', 'Node.appendChild()')}}</td>
   <td>{{Spec2('DOM3 Core')}}</td>
   <td>No change from {{SpecName("DOM2 Core")}}.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 Core', 'core.html#ID-184E7107', 'Node.appendChild()')}}</td>
   <td>{{Spec2('DOM2 Core')}}</td>
   <td>No change from {{SpecName("DOM1")}}.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM1', 'level-one-core.html#ID-184E7107', 'Node.appendChild()')}}</td>
   <td>{{Spec2('DOM1')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.Node.appendChild")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("Node.removeChild()")}}</li>
 <li>{{domxref("Node.replaceChild()")}}</li>
 <li>{{domxref("Node.insertBefore()")}}</li>
 <li>{{domxref("Node.hasChildNodes()")}}</li>
 <li>{{domxref("Element.insertAdjacentElement()")}}</li>
 <li>{{domxref("ParentNode.append()")}}</li>
</ul>
